;============================================================================
;	S-BASIC AM7Jpb`
;============================================================================
	ORG	0000h

_HL_	EQU	06A4h		; JP (HL) ̃AhX

	BINCLUDE "SBASIC.MZT"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ARRANGE	80h+0062h, 2, 0

	DW	HookJoy				; WCXeBbNǂݎ

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ARRANGE	80h+0EEDh, 0F97h-0EEDh, 0
	ORG	0EEDh

;------------------------------------------------------------------------------
; IN :	A = 0 : JA1 XeBbNX( 0  255 E)
;	    1 : JA2 XeBbNY( 0  255 )
;	    2 : JB1 XeBbNX
;	    3 : JB2 XeBbNY
;	    4 : JA1 {^1
;	    5 : JA2 {^2
;	    6 : JB1 {^1
;	    7 : JB2 {^2
; OUT:	(0065).b = 8(pressed) / 0(released)	({^,     A=0`3̎)
;	(0066).b = 0-255			(XeBbN, A=4`7̎)
;	A = ɑ΂Ԃl ((0065).b܂(0066).bƓ)
;	Cy = 1: XeBbN̒lǂ / Cy = 0: {^̒lǂ
;	Z: {^͉ĂȂ / NZ: {^Ă
; DES:	AF
;------------------------------------------------------------------------------
HookJoyTbl:
	DB	0_000000_0b	; RL, Stick, Joy1
	DB	0_000001_0b	; UD, Stick, Joy1
	DB	1_000000_0b	; RL, Stick, Joy2
	DB	1_000001_0b	; UD, Stick, Joy2
	DB	0_000001_1b	; A, Button, Joy1
	DB	0_000010_1b	; B, Button, Joy1
	DB	1_000001_1b	; A, Button, Joy2
	DB	1_000010_1b	; B, Button, Joy2

HookJoy:
	PUSH	BC
	PUSH	HL
	LD	HL, HookJoyTbl
	ADD	A, L
	LD	L, A
	LD	A, (HL)
	AND	7Fh
	RRA
	JR	C, ReadButton
ReadStick:
	CALL	ReadJoyPort
	DEC	B		; UP/DOWN ?
	LD	BC, 0C08h	; RIGHT/LEFT (RIGHT = 255)
	JR	NZ, @f
	LD	BC, 3010h	; UP/DOWN (DOWN = 255)
@@:	AND	B
	XOR	B
	JR	Z, @1f		; j[g
	CP	C
	LD	A, 255
	JR	Z, @2f
	XOR	A
	DB	21h		; (2byte skip)
@1:	LD	A, 128
@2:	LD	(0066h), A
	SCF
@9:	POP	HL
	POP	BC
	RET
ReadButton:
	CALL	ReadJoyPort
	AND	B		; Z :Ă A=0 / NZ: ĂȂ A=B
	XOR	B		; NZ:Ă A=B / Z : ĂȂ A=0
	JR	Z, @f		; Z :ĂȂ A=0, Cy=0
	LD	A, 8		; NZ:Ă   A=8, Cy=0
@@:	LD	(0065h), A
	JR	@9b

ReadJoyPort:
	PUSH	AF
	BIT	7, (HL)		; (܂ZtOωȂ)
	LD	HL, 0E008h
	LD	BC, 0710h
	DI
	OUT	(0E3h), A

	JR	NZ, ReadJoyPort2
;----------------------------------------------------------------
; WCXeBbN|[g1gMSXdl̃WCXeBbNǂ
;	OUT: A = ..UDRLBA
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort1:

CheckJoy1:				; ڑ`FbN JA2LowɂȂ邩ǂ
	LD	A, 04h			; JA2
@@:	AND	(HL)
	DJNZ	@b
@9:	LD	A, 3Fh
	JR	NZ, @8f

	LD	BC,  0E04h		; JA2
	;
	; JA2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJA2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	*****.A*
	RRCA			;  4 (11)	******.A
	RRCA			;  4 (15)	*******.	Cy = A
	RL	B		;  8 (23)	..wwww.A	wwww = 0111
	LD	A, 06h		;  7 (30)

	AND	(HL)		;  7 ( 7)	.....yB.	y = y1
	ADD	A, B		;  4 (11)	..wwwwBA	if (y1==0) wwww = 0111 else wwww = 1000
	AND	33h		;  7 (18)	..yy..BA	yy = y1 + 1
	RRCA			;  4 (22)	A..yy..B
	RRCA			;  4 (26)	BA..yy..
	LD	B, A		;  4 (30)

	LD	A, (HL)		;  7 ( 7)	*****yR*	y = y0
	AND	06h		;  7 (14)	.....yR.
	ADD	A, B		;  4 (18)	BA..yyR.	yy = y1 + y0 + 1
	RLCA			;  4 (22)	A..yyR.B
	RLCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	******L*
	RLCA			;  4 (11)	*****L**
	AND	C		;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA

@8:	OUT	(0E1h), A
	EI
	POP	BC
	RET

;----------------------------------------------------------------
; WCXeBbN|[g2gMSXdl̃WCXeBbNǂ
;	OUT: A = ..UDRLBA
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort2:

CheckJoy2:			; ڑ`FbN JB2LowɂȂ邩ǂ
	LD	A, C		; JB2
@@:	AND	(HL)
	DJNZ	@b
	JR	NZ, @9b

	;
	; JB2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJB2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	***.A***
	AND	L		;  4 (11)	....A...
	OR	H		;  4 (15)	www.A...	www = 111
	RRCA			;  4 (19)	wwww.A..	wwww = 0111
	LD	B, A		;  4 (23)
	LD	A, 18h		;  7 (30)

	AND	(HL)		;  7 ( 7)	...yB...	y = y1
	ADD	A, B		;  4 (11)	wwwwBA..	if (y1==0) wwww = 0111 else wwww = 1000
	AND	0CCh		;  7 (18)	yy..BA..	yy = y1 + 1
	RRCA			;  4 (22)	.yy..BA.
	LD	B, A		;  4 (26)	.yy..BA.
	NOP			;  4 (30)	(delay)

	LD	A, (HL)		;  7 ( 7)	***yR***	y = y0
	AND	18h		;  7 (14)	...yR...
	RLCA			;  4 (18)	..yR....
	ADD	A, B		;  4 (22)	.yyR.BA.	yy = y1 + y0 + 1
	RRCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	***yL***
	AND	L		;  4 (11)	....L...
	RRCA			;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA

	JR	@8b

IF ($ > 0F97h)
	JR	0F97h-126
ENDIF

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END
