;============================================================================
;	Sonic Birds MZ-1500 AM7Jpb`
;============================================================================
	ORG	1500h-80h

	BINCLUDE "SB.MZT"
	DS	130h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	1500h-80h+12h, 2, 0

	DW	0AD00h

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	1500h, 3, 0

	JP	Hook_Init

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	1D10h, 14h, 0

	LD	HL, 0E007h
	LD	(HL), 10_01_000_0b	; Ch.2, Low Byte only, Mode 0
	LD	(HL), 01_01_010_0b	; Ch.1, Low Byte only, Mode 2
	DEC	L
	LD	(HL), 0Ah
	DEC	L
	LD	(HL), 0Ah
SkipReadJoy:
	CALL	ReadJoyPort1
	LD	(JoyPortData), A

	EI
	RET

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	1E54h, 3, 0

	CALL	Hook_Cursor

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	1F94h, 3, 0

	CALL	Hook_X

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	20C0h, 3, 0

	CALL	Hook_Z

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	2F0Ah, 3, 0

	CALL	Hook_Space

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	31BCh, 3, 0

	CALL	Hook_WaitStart

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	31CFh, 3, 0

	CALL	Hook_NameEntryCursor

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE	31ECh, 3, 0

	CALL	Hook_NameEntryButton

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ARRANGE 0C0D0h, 130h, 0

	ORG	1400h

;----------------------------------------------------------------
; WCXeBbN|[g1gMSXdl̃WCXeBbNǂ
;	OUT: A = srUDRLBA (s:SELECT r:RUN)
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort1:
	LD	HL, 0E008h
	LD	BC,  0E04h		; JA2
	;
	; JA2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJA2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	*****.A*
	RRCA			;  4 (11)	******.A
	RRCA			;  4 (15)	*******.	Cy = A
	RL	B		;  8 (23)	..wwww.A	wwww = 0111
	LD	A, 06h		;  7 (30)

	AND	(HL)		;  7 ( 7)	.....yB.	y = y1
	ADD	A, B		;  4 (11)	..wwwwBA	if (y1==0) wwww = 0111 else wwww = 1000
	AND	33h		;  7 (18)	..yy..BA	yy = y1 + 1
	RRCA			;  4 (22)	A..yy..B
	RRCA			;  4 (26)	BA..yy..
	LD	B, A		;  4 (30)

	LD	A, (HL)		;  7 ( 7)	*****yR*	y = y0
	AND	06h		;  7 (14)	.....yR.
	ADD	A, B		;  4 (18)	BA..yyR.	yy = y1 + y0 + 1
	RLCA			;  4 (22)	A..yyR.B
	RLCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	******L*
	RLCA			;  4 (11)	*****L**
	AND	C		;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA

	OR	0C0h		;		11UDRLBA
	LD	C, A
	AND	0Ch		;		0000RL00
	LD	A, C
	RET	NZ

	;
	; RL == 00 Ȃ UD fR[h RUN, SELECT ̏Ԃɕϊ
	;
				;   UD=11     UD=10     UD=01
	AND	30h		; 00110000  00100000  00010000
	DEC	A		; 00101111  00011111  00001111
	ADD	A, A		; 01011110  00111110  00011110
	ADD	A, A		; 10111100  01111100  00111100
	OR	B		; 101111BA  011111BA  001111BA

	RET

;------------------------------------------------------------------------------
; [X]B{^Œu
;
; OUT:	Z:Ă NZ:ĂȂ
; DES:	AF
;------------------------------------------------------------------------------
Hook_X:
	CALL	@f
	RET	NZ

@1:	LD	A, 01h
	XOR	01h
	LD	(@1b+1), A
	RET

@@:	INC	L
	BIT	0, (HL)
	RET	Z
	LD	A, (JoyPortData)
	BIT	1, A
	RET

;------------------------------------------------------------------------------
; [Z]A{^Œu
;
; OUT:	Z:Ă NZ:ĂȂ
; DES:	AF
;------------------------------------------------------------------------------
Hook_Z:
	CALL	@f
	RET	NZ

@1:	LD	A, 01h
	XOR	01h
	LD	(@1b+1), A
	RET

@@:	INC	L
	BIT	6, (HL)
	RET	Z
	LD	A, (JoyPortData)
	BIT	0, A
	RET

;------------------------------------------------------------------------------
; [SPACE]A/B/RUN{^Œu
;
; OUT:	Z:Ă NZ:ĂȂ
; DES:	AF
;------------------------------------------------------------------------------
Hook_Space:
	INC	L
	BIT	4, (HL)
	RET	Z
	LD	A, (JoyPortData)
Hook_Space_Buttons EQU $+1
	OR	10111100b
	ADD	A, 1		; A/B/RUNĂ Cy=0, ĂȂ Cy=1
	SBC	A, A		; A/B/RUNĂ Z,    ĂȂ NZ
	RET

;------------------------------------------------------------------------------
; J[\L[\L[Œu
;
; OUT:	(1F07h).b = Row 7 ̃f[^
; DES:	AF
;------------------------------------------------------------------------------
Hook_Cursor:
	CP	0FFh
	JR	NZ, @f
	LD	A, (0E001h)
JoyPortData EQU $+1
	LD	A, 0FFh
	OR	0C3h
@@:	LD	(1F07h), A
	RET

;------------------------------------------------------------------------------
; J[\L[\L[Œu
;
; OUT:	B  = Row 7 ̃f[^
;	HL = 2FF0h
; DES:	AF
;------------------------------------------------------------------------------
Hook_NameEntryCursor:
	LD	A, (JoyPortData)
	OR	11110011b
	AND	B
	LD	B, A
	LD	HL, 2FF0h
	RET

;------------------------------------------------------------------------------
; [X]A/B{^Œu
;
; OUT:	A  = Row 2 ̃f[^
;	HL = 2FF0h
; DES:	AF
;------------------------------------------------------------------------------
Hook_NameEntryButton:
	LD	HL, 2FF0h
	CP	0FFh
	RET	NZ
	LD	A, (JoyPortData)
	OR	10111100b
	INC	A
	CPL
	RET	Z
	LD	A, 0FEh
	RET

;------------------------------------------------------------------------------
; [SPACE]҂[`: l[Gg[
;
; OUT:	Z:Ă NZ:ĂȂ
; DES:	AF
;------------------------------------------------------------------------------
Hook_WaitStart:
	LD	A, 10111111b		; RUN̂
	LD	(Hook_Space_Buttons), A
	CALL	2ECFh
	LD	A, 10111100b		; RUN/A/B
	LD	(Hook_Space_Buttons), A
	RET

Hook_End:
;------------------------------------------------------------------------------
; WCXeBbNڑ`FbN
;------------------------------------------------------------------------------
	ORG	$-1400h + 0C0D0h

;------------------------------------------------------------------------------
; WCXeBbNڑĂ邩ǂ`FbN
; JA2/JB2LowɂȂ邩ǂ
;	OUT: Cy = 0  ڑĂ
;		= 1  ڑĂȂ
;	DES: AF, BC, HL
;------------------------------------------------------------------------------
CheckJoy1:
	LD	A, 04h		; JA2
	LD	B, 7
	LD	HL, 0E008h
@@:	AND	(HL)
	DJNZ	@b
	RET	Z
	SCF
	RET

Hook_Init:
	CALL	CheckJoy1		; AM7JA_v^ڑ`FbN
	JR	NC, @f
	LD	HL, 0FF3Eh		; ڑĂȂ΁Aǂݎ胋[`XLbv
	LD	(SkipReadJoy), HL
	XOR	A
	LD	(SkipReadJoy+2), A
@@:
	LD	HL, 0C0D0h
	LD	DE, 1400h
	LD	BC, Hook_End - 1400h
	LDIR

	JP	272Eh


	END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END
