;============================================================================
;	Thunder Force MZ-1500 AM7Jpb`
;============================================================================
	ORG	0000h

PATCH_OFFSET EQU 0080h

PATCH_START MACRO
	ARRANGE PATCH_OFFSET + %1, %2, 0
	ORG	%1
	ENDM

PATCH_END MACRO
	ORG	$+PATCH_OFFSET
	END
	ENDM

	BINCLUDE "TF.MZT"
	DS	0C0h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ARRANGE	0012h, 2, 0

	DW	0B300h

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	PATCH_START	0018h, 3

	JP	Hook_Init

	PATCH_END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	PATCH_START	0712h, 3

	CALL	Hook_0712

	PATCH_END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	PATCH_START	0B240h, 0C0h
;----------------------------------------------------------------
; WCXeBbN|[g1gMSXdl̃WCXeBbNǂ
;	OUT: A = ..UDRLBA
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort1:
	PUSH	BC
	PUSH	HL
	CALL	CheckIFF
	SBC	A, A		; DI:00h EI:FFh
	AND	0FBh		; DI:00h EI:FBh
	LD	(@9f), A	; DI:NOP EI:EI

	DI
	LD	HL, 0E008h
	LD	BC,  0E04h		; JA2
	;
	; JA2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJA2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	*****.A*
	RRCA			;  4 (11)	******.A
	RRCA			;  4 (15)	*******.	Cy = A
	RL	B		;  8 (23)	..wwww.A	wwww = 0111
	LD	A, 06h		;  7 (30)

	AND	(HL)		;  7 ( 7)	.....yB.	y = y1
	ADD	A, B		;  4 (11)	..wwwwBA	if (y1==0) wwww = 0111 else wwww = 1000
	AND	33h		;  7 (18)	..yy..BA	yy = y1 + 1
	RRCA			;  4 (22)	A..yy..B
	RRCA			;  4 (26)	BA..yy..
	LD	B, A		;  4 (30)

	LD	A, (HL)		;  7 ( 7)	*****yR*	y = y0
	AND	06h		;  7 (14)	.....yR.
	ADD	A, B		;  4 (18)	BA..yyR.	yy = y1 + y0 + 1
	RLCA			;  4 (22)	A..yyR.B
	RLCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	******L*
	RLCA			;  4 (11)	*****L**
	AND	C		;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA
	OR	0C0h

	POP	HL
	POP	BC
@9:	EI
	RET

;------------------------------------------------------------------------------
; WCXeBbNڑĂ邩ǂ`FbN
; JA2/JB2LowɂȂ邩ǂ
;	OUT: Cy = 0  ڑĂ
;		= 1  ڑĂȂ
;	DES: AF, BC, HL
;------------------------------------------------------------------------------
CheckJoy1:
	LD	A, 04h		; JA2
	LD	B, 7
	LD	HL, 0E008h
@@:	AND	(HL)
	DJNZ	@b
	RET	Z
	SCF
	RET

;------------------------------------------------------------------------------
; DI/EIԂ̃`FbN (̃[`00xxhɔzuȂ)
;
; OUT:	Cy = 0 : DI
;	   = 1 : EI
; DES:	AF, HL
;------------------------------------------------------------------------------
CheckIFF:
	LD	HL, -1	; 10 (10)
	ADD	HL, SP	; 11 (21)		Cy = 1
	LD	(HL), 0	; 10 (31)
	LD	A, I	;  9 (40)
	RET	PE	;  5 (45) / 11 (51)	EIԂȂ Cy=1 ŋA
	XOR	A	;  4 (49)		DIԂȂA荞݂ǂ`FbN
	SUB	(HL)	;  7 (56)		A==00h(荞݂ĂȂ)Ȃ Cy=0AłȂ Cy=1
	RET		; 10 (66)

;------------------------------------------------------------------------------
; [SPACE]{^Œu
;
; IN :	A = Row
; OUT:	A = Row N ̃f[^
; DES:	AF
;------------------------------------------------------------------------------
Hook_0712:
	AND	0Fh
	ADD	A, A
	LD	(@f+1), A
	LD	A, (0E001h)
	CP	0FFh
	RET	NZ
@@:	JR	$
	JR	Row_None
	JR	Row1
	JR	Row2
	JR	Row_None
	JR	Row_None
	JR	Row_None
	JR	Row6
	JR	Row7
	JR	Row8
	JR	Row_None
Row_None:
	LD	A, 0FFh
	RET

Row8:
	CALL	ReadJoyPort1
	LD	(JoyPortData), A
	JR	Row_None

Row1:
JoyPortData EQU $+1
	LD	A, 0FFh
	BIT	1, A		; [Z]
	JR	NZ, Row_None
	LD	A, 0BFh
	RET

Row2:
	LD	A, (JoyPortData) ; [X]
	RET

Row6:
	LD	A, (JoyPortData)
	RRA
	JR	NC, @f
	RRA
	JR	C, Row_None
@@:	LD	A, 0EFh		; [SPACE]
	RET

Row7:
	LD	A, (JoyPortData)
	OR	0C3h
	RET

;------------------------------------------------------------------------------
; WCXeBbNڑ`FbN
;------------------------------------------------------------------------------
Hook_Init:
	DI
	LD	SP, 0D000h
	CALL	CheckJoy1		; AM7JA_v^ڑ`FbN
	JR	NC, @f
	LD	HL, 0FF3Eh		; ڑĂȂ΁Aǂݎ胋[`XLbv
	LD	(ReadJoyPort1), HL
	LD	A, 0C9h
	LD	(ReadJoyPort1+2), A
@@:	JP	0402h

	PATCH_END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END
