;============================================================================
;	ZEPLIS3 ጸpb`
;============================================================================
	ORG	3000h

RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

WTVRAM	EQU	2000h		; zVRAM eLXg
WAVRAM	EQU	2800h		; zVRAM Agr[g

RAPID	EQU	0		; [Z]ŘA
SIOJOY	EQU	0		; MZ-1500 SIO-B Joystick
LPTJOY	EQU	0		; MZ-700/1500 LPT Joystick
AM7JOY	EQU	1		; MZ-700/1500 AM7J adapter
;;;QD	EQU	0		; QDp̃u[gvO

;
;	ZEPLIS3{̂[h
;
;;;CALL 09B3h
	LD	A, (06F9h)	; "1Z-009A"  'A'
	CP	'B'
	JR	NZ, TapeLoad	; 1Z-009BłȂ΃e[v烍[h
	LD	A, B
	SUB	03h
	JR	NZ, TapeLoad	; 1Z-009B  BC=0300h ȂQD烍[h
	OR	C
	JR	NZ, TapeLoad
QDLoad:
	CALL	NL
	CALL	0EF7Ah			; IOCS FLAG RESET
	CALL	0EFB5h			; QUICK DISK READY CHECK
	JR	C, QDErr		; QD ERROR
	LD	DE, 0EEFBh		; "Loading "
	RST	18h			; Print string
	LD	HL, QDPara
	LD	DE, 1130h
	LD	BC, 0006h
	LDIR
	CALL	0E80Dh			; QDIO
QDErr:	JP	C, 0F2BBh		; QD ERROR
	LD	HL, ApplyPatch
	LD	(1108h), HL		; QEXADR
	JP	0EF1Dh			; LOAD&RUN
QDPara:	DW	0003h, 10F0h, 0040h	; QDPA = 3(READ), QDPB = INFO, QDPC = Buf addr, QDPE = size

TapeLoad:
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR
;
;	pb`𓖂Ă
;
ApplyPatch:
	LD	HL, PATCHDATA
@3:	LD	E, (HL)
	INC	HL
	LD	D, (HL)		; DE = pb`ăAhX
	LD	A, D
	OR	E
	JR	Z, @1f
	INC	HL
	LD	B, (HL)		; B = f[^̒
	INC	HL
@2:	LD	A, (HL)
	INC	HL
	LD	(DE), A
	INC	DE
	DJNZ	@2b
	JR	@3b
@1:

;
;	zʂ
;
	LD	HL, WTVRAM
	LD	DE, WTVRAM+1
	LD	BC, 1000
	LD	(HL), 0
	LDIR
	LD	HL, WAVRAM
	LD	DE, WAVRAM+1
	LD	BC, 1000
	LD	(HL), 70h
	LDIR

IF LPTJOY
;
;	LPTJOY
;
	LD	A, 0FFh
	OUT	(0FFh), A
ENDIF ;;;LPTJOY

IF SIOJOY
;
;	SIOJOY
;
InitSIOB:
	LD	HL, @1f
	LD	BC, (@2f - @1f) : 0F7h	; SIO `lBRg[
	OTIR
	JR	@2f

@1:	DB	18h		; WR0 `lEZbg
	DB	04h		; WR0 WR4|Cg
	DB	04h		; WR4 x1NbNEXgbvrbg1rbgEpeBȂ
	DB	01h		; WR0 WR1|Cg
	DB	00h		; WR1 荞ݕs
	DB	03h		; WR0 WR3|Cg
	DB	0C1h		; WR3 8rbgEV[oCl[u
@2:
ENDIF ;;;SIOJOY

IF AM7JOY
;
;	AM7JOY
;
	CALL	CheckJoy1		; AM7JA_v^ڑ`FbN
	JR	NC, @f
	LD	HL, 0FF3Eh		; ڑĂȂ΁Aǂݎ胋[`XLbv
	LD	(ReadJoyPort1), HL
	LD	A, 0C9h
	LD	(ReadJoyPort1+2), A
@@:	
ENDIF ;;;AM7JOY

;
;	ZEPLIS3MZ-700[hŎs
;
	LD	HL, 0
	LD	(0CFF4h), HL
	LD	A, 22h
	JP	0A91Ah

;============================================================================
;	WAIT[ṽtbN[`
;	̍XVt[܂ő҂AzVRAMVRAMɓ]
;============================================================================
WAITLOOP_HOOK:
	;
	;	VBLNK̗҂
	;
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b
	; fallthru
;============================================================================
;	zVRAMVRAM]
;	荞݋֎~ԂŌĂԂ
;	SWX^j
;============================================================================
VRAMtransfer:
	DI
	LD	(@7f+1), SP
	LD	HL, WTVRAM
	LD	(@5f+1), HL
	LD	HL, WAVRAM
	LD	(@6f+1), HL
	LD	IX, 0D000h + 10
	LD	IY, 0D800h + 10
	LD	BC, 11
	LD	A, (0D000h)	; ^C~O킹
	LD	A, 91		; (1000/11) = 90.9
				; \  :  uLO
@1:				;  (<=165)  :	(<=63)
	EX	AF, AF'		;'; 4 (4)
@5:	LD	SP, WTVRAM	; 10 (14)
	POP	DE		; 10 (24)
	POP	HL		; 10 (34)
	EXX			;  4 (38)
	POP	AF		; 10 (48)
	POP	BC		; 10 (58)
	POP	DE		; 10 (68)
	POP	HL		; 10 (78)
	DEC	SP		;  6 (84)
	LD	(@5b+1), SP	; 20 (104)
	LD	SP, IX		; 10 (114)
	LD	(IX), L		; 16 (130)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IX, BC		; 15 (145)

@6:	LD	SP, WAVRAM	; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	POP	AF		; 10 (44)
	POP	BC		; 10 (54)
	POP	DE		; 10 (64)
	POP	HL		; 10 (74)
	DEC	SP		;  6 (80)
	LD	(@6b+1), SP	; 20 (100)
	LD	SP, IY		; 10 (110)
	LD	(IY), L		; 16 (126)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IY, BC		; 15 (141)

	EX	AF, AF'		;'; 4 (145)
	DEC	A		;  4 (149)
	JP	NZ, @1b		; 10 (159)

@7:	LD	SP, 0000h
	LD	A, (0CF76h)
	OR	A
	RET	Z
	EI
	RET

;============================================================================
;	(X,Y)VRAM
;============================================================================
XYtoVRAM:
	LD	L, C		; (X,Y)VRAM
	LD	C, B
	LD	B, 0
	LD	H, 0D0h
	SLA	C
	SLA	C
	SLA	C
	RL	B
	ADD	HL, BC
	SLA	C
	RL	B
	SLA	C
	RL	B
	ADD	HL, BC
	RET

;============================================================================
;	J[PUT@[` tbN
;============================================================================
PUTCHR_HOOK:
	CALL	0ABBCh
	JP	VRAMtransfer

PUTCHR_HOOK2:
	LD	A, 0D0h
	LD	(0ABFFh), A
	LD	A, 0D8h
	LD	(0AC03h), A
	CALL	0ABBCh
	LD	A, 20h
	LD	(0ABFFh), A
	LD	A, 28h
	LD	(0AC03h), A
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF RAPID
;============================================================================
;	t@C^[ L[ tbN
;============================================================================
FIGHTER_BEAM_KEY_HOOK:		; [SPACE]
	LD	(HL), 0F2h	; [X]
	LD	A, (DE)
	RRCA
	RET	C
@@:	LD	A, 11111101b
	XOR	00000010b	; Ă΂邽тɔ]
	LD	(@b+1), A
	RET
ENDIF ;RAPID

IF SIOJOY
;============================================================================
;	GETKY(001Bh) tbN
;============================================================================
GETKY_HOOK_TITLE:		; ^Cgʗp ([S])
	IN	A, (0F5h)
	IN	A, (0F5h)
	IN	A, (0F5h)
	RLCA			; X^[g{^Ă
	LD	A, 'S'		; 'S'Ԃ
	RET	NC
	JP	001Bh

GETKY_HOOK_INGAME:		; Q[p ([A])
	LD	A, (SIOJOY_INPUT)
	RLCA			; X^[g{^Ă
	LD	A, 'A'		; 'A'Ԃ
	RET	NC
	JP	001Bh

;============================================================================
;	t@C^[ L[ tbN
;============================================================================
FIGHTER_MOVE_KEY_HOOK:		; J[\L[
	IN	A, (0F5h)
	IN	A, (0F5h)
	IN	A, (0F5h)
	LD	(HL), 0F7h
	LD	HL, SIOJOY_INPUT
	LD	(HL), A
	LD	A, (DE)
SIOJOY_INPUT EQU $+1
	AND	0FFh
	EX	DE, HL
	RET

FIGHTER_BEAM_KEY_HOOK:		; [SPACE]
	LD	A, (SIOJOY_INPUT)
	BIT	1, A		; A{^ĂH
	JR	Z, @f		; VbgA
	RLCA			; B{^Bit1
	OR	11111101b	; Bit1 = Ă:0 ĂȂ:1
	RET
@@:	LD	A, 11111101b
	XOR	00000010b	; Ă΂邽тɔ]
	LD	(@b+1), A
	RET

FIGHTER_SPECIAL_KEY_HOOK:	; [Z]
	LD	A, (SIOJOY_INPUT)
	OR	10111111b	; C{^
	RLCA			; C1111111
	RLCA			; 1111111C
	RET

ENDIF ;;;SIOJOY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF LPTJOY
;============================================================================
;	GETKY(001Bh) tbN
;============================================================================
GETKY_HOOK_TITLE:		; ^Cgʗp ([S])
	CALL	READ_LPTJOY
	OR	11111100b
	INC	A		; {^Ă
	LD	A, 'S'		; 'S'Ԃ
	RET	NZ
	JP	001Bh

;============================================================================
;	t@C^[ L[ tbN
;============================================================================
FIGHTER_MOVE_KEY_HOOK:		; J[\L[
	CALL	READ_LPTJOY
	LD	(HL), 0F7h
	LD	HL, LPTJOY_INPUT
	LD	(HL), A
	LD	A, (DE)
LPTJOY_INPUT EQU $+1
	AND	0FFh
	EX	DE, HL
	RET

FIGHTER_BEAM_KEY_HOOK:		; [SPACE]
	LD	A, (LPTJOY_INPUT)
	OR	11111101b	; Bit1 = B{^
	RET

FIGHTER_SPECIAL_KEY_HOOK:	; [Z]
	LD	A, (LPTJOY_INPUT)
	OR	11111110b	; Bit0 = A{^
	RET

;
; LPT WCXeBbN
;
READ_LPTJOY:
	PUSH	BC
	PUSH	DE
	LD	BC, 7CFEh
	OUT	(C), 0		; RDP:IRT = 00b
	IN	A, (0FEh)	; A = ****00UD
	ADD	A, A		; A = ***00UD0
	ADD	A, A		; A = **00UD00
	OUT	(C), B		; RDP:IRT = 01b
	IN	E, (C)		; E = ****00RL
	OR	E		; A = ****UDRL
	RLCA
	RLCA			; A = **UDRL**
	OR	0C3h		; A = 11UDRL11
	LD	E, A		; E = 11UDRL11
	OUT	(C), C		; RDP:IRT = 11b
	IN	A, (0FEh)	; A = ****00BA
	OR	B		; A = *11111BA
	AND	E		; A = *1UDRLBA
	POP	DE
	POP	BC
	RET
ENDIF ;;;JPTJOY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF AM7JOY
;============================================================================
;	GETKY(001Bh) tbN
;============================================================================
GETKY_HOOK_TITLE:		; ^Cgʗp ([S])
	PUSH	HL
	CALL	ReadJoyPort1
	POP	HL
	OR	0BCh		; A, B, STARTĂ
	INC	A
	JP	Z, 001Bh
	XOR	A
	CALL	WaitRunButton	; RUN̂҂
	LD	A, 'S'		; 'S'Ԃ
	RET

GETKY_HOOK_INGAME:		; Q[p ([A])
	LD	A, (AM7JOY_INPUT)
	AND	40h		; X^[g{^ĂPAUSE
	JP	NZ, 001Bh	; ĂȂΌ̔ѐ
	;
	; PAUSE
	;
	XOR	A
	CALL	WaitRunButton	; RUN̂҂
	LD	A, 40h
	CALL	WaitRunButton	; RUN̂҂
	XOR	A
	CALL	WaitRunButton	; RUN̂҂
	CALL	ReadJoyPort1
	RLA			; PAUSE甲ƂSELECTĂA˃[hɂ
	SBC	A, A
	AND	0C9h
	LD	(RAPID_ON_OFF), A
	XOR	A
	RET

WaitRunButton:
	LD	C, A
@@:	CALL	Delay
	PUSH	BC
	CALL	ReadJoyPort1
	POP	BC
	AND	40h
	CP	C
	JR	Z, @b
	RET

Delay:	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	RET	P
	JR	@b

;============================================================================
;	t@C^[ L[ tbN
;============================================================================
FIGHTER_MOVE_KEY_HOOK:		; J[\L[
	LD	(HL), 0F7h
	LD	A, (DE)
	OR	0C3h
	LD	E, A
	CALL	ReadJoyPort1
	AND	E
	LD	DE, AM7JOY_INPUT
	LD	(DE), A
	RET

FIGHTER_BEAM_KEY_HOOK:		; [SPACE]
AM7JOY_INPUT EQU $+1
	LD	A, 0FFh
	OR	11111101b	; Bit1 = Ă:0 ĂȂ:1
RAPID_ON_OFF:
	RET			; RET:A˖  NOP:A˗L
	BIT	1, A
	RET	NZ		; ĂȂ΋A
@@:	LD	A, 11111101b
	XOR	00000010b	; Ă΂邽тɔ]
	LD	(@b+1), A
	RET

FIGHTER_SPECIAL_KEY_HOOK:	; [Z]
	LD	A, (AM7JOY_INPUT)
	OR	11111110b	; A{^
	RET

;----------------------------------------------------------------
; WCXeBbN|[g1gMSXdl̃WCXeBbNǂ
;	OUT: A = srUDRLBA (s:SELECT r:RUN)
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort1:
	CALL	CheckIFF
	JR	NC, @1f		; DIԂ
	CALL	@1f
	EI
	RET

@1:	DI
	LD	HL, 0E008h
	LD	BC,  0E04h		; JA2
	;
	; JA2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJA2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	*****.A*
	RRCA			;  4 (11)	******.A
	RRCA			;  4 (15)	*******.	Cy = A
	RL	B		;  8 (23)	..wwww.A	wwww = 0111
	LD	A, 06h		;  7 (30)

	AND	(HL)		;  7 ( 7)	.....yB.	y = y1
	ADD	A, B		;  4 (11)	..wwwwBA	if (y1==0) wwww = 0111 else wwww = 1000
	AND	33h		;  7 (18)	..yy..BA	yy = y1 + 1
	RRCA			;  4 (22)	A..yy..B
	RRCA			;  4 (26)	BA..yy..
	LD	B, A		;  4 (30)

	LD	A, (HL)		;  7 ( 7)	*****yR*	y = y0
	AND	06h		;  7 (14)	.....yR.
	ADD	A, B		;  4 (18)	BA..yyR.	yy = y1 + y0 + 1
	RLCA			;  4 (22)	A..yyR.B
	RLCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	******L*
	RLCA			;  4 (11)	*****L**
	AND	C		;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA

	OR	0C0h		;		11UDRLBA
	LD	C, A
	AND	0Ch		;		0000RL00
	LD	A, C
	RET	NZ

	;
	; RL == 00 Ȃ UD fR[h RUN, SELECT ̏Ԃɕϊ
	;
				;   UD=11     UD=10     UD=01
	AND	30h		; 00110000  00100000  00010000
	DEC	A		; 00101111  00011111  00001111
	ADD	A, A		; 01011110  00111110  00011110
	ADD	A, A		; 10111100  01111100  00111100
	OR	B		; 101111BA  011111BA  001111BA

	RET

;------------------------------------------------------------------------------
; WCXeBbNڑĂ邩ǂ`FbN
; JA2/JB2LowɂȂ邩ǂ
;	OUT: Cy = 0  ڑĂ
;		= 1  ڑĂȂ
;	DES: AF, BC, HL
;------------------------------------------------------------------------------
CheckJoy1:
	LD	A, 04h		; JA2
	LD	B, 7
	LD	HL, 0E008h
	AND	(HL)
	DJNZ	@b
	RET	Z
	SCF
	RET

;------------------------------------------------------------------------------
; DI/EIԂ̃`FbN (̃[`00xxhɔzuȂ)
;
; OUT:	Cy = 0 : DI
;	   = 1 : EI
; DES:	AF, HL
;------------------------------------------------------------------------------
CheckIFF:
	LD	HL, -1	; 10 (10)
	ADD	HL, SP	; 11 (21)		Cy = 1
	LD	(HL), 0	; 10 (31)
	LD	A, I	;  9 (40)
	RET	PE	;  5 (45) / 11 (51)	EIԂȂ Cy=1 ŋA
	XOR	A	;  4 (49)		DIԂȂA荞݂ǂ`FbN
	SUB	(HL)	;  7 (56)		A==00h(荞݂ĂȂ)Ȃ Cy=0AłȂ Cy=1
	RET		; 10 (66)
 
ENDIF ;;;AM7JOY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;============================================================================
;	pb`f[^
;============================================================================
PATCHDATA:	; AhX(W), (B), f[^(B)...

	;
	; E̕\
	;
	DW	0A967h
	DB	1
	DB	28h

	DW	0A970h
	DB	1
	DB	20h

	DW	0A979h
	DB	1
	DB	21h

	;
	; ^Cg
	;
	DW	0A9E6h
	DB	1
	DB	28h

	DW	0A9E9h
	DB	1
	DB	28h

	DW	0AA07h
	DB	2
	DW	PUTCHR_HOOK

	;
	; ʃNA
	;
	DW	0AAE2h
	DB	1
	DB	20h

	;
	; WAIT[v tbN
	;
	DW	0AAF4h
	DB	3
	JP	WAITLOOP_HOOK

	;
	; (X,Y)VRAM
	;
	DW	0AB0Ch
	DB	1
	DB	20h

	;
	; J[PUT@[`
	;
	DW	0ABFFh
	DB	1
	DB	20h

	DW	0AC03h
	DB	1
	DB	28h

	;
	; _
	;
	DW	0B701h
	DB	1
	DB	21h

	DW	0B711h
	DB	1
	DB	21h

	DW	0B721h
	DB	1
	DB	21h

	DW	0B731h
	DB	1
	DB	21h

	DW	0B737h
	DB	1
	DB	21h

	DW	0B76Dh
	DB	1
	DB	21h

	DW	0B770h
	DB	1
	DB	21h

	DW	0B778h
	DB	1
	DB	21h

	;
	; GlM[Q[W\
	;
	DW	0B7DFh
	DB	1
	DB	20h

	DW	0B7ECh
	DB	1
	DB	23h

	;
	; t@C^[
	;
	DW	0B86Fh
	DB	2
	DW	XYtoVRAM

	DW	0B8ECh
	DB	2
	DW	PUTCHR_HOOK2

	;
	; c@\
	;
	DW	0B966h
	DB	1
	DB	23h

	;
	; p[AbvEp[c\
	;
	DW	0BA44h
	DB	1
	DB	22h

	;
	; NbV
	;
	DW	0BCEFh
	DB	2
	DW	XYtoVRAM

IF RAPID
	;
	; t@C^[r[ L[
	;
	DW	0ACFEh
	DB	3
	CALL	FIGHTER_BEAM_KEY_HOOK

ENDIF ;RAPID

IF SIOJOY
	;
	; ^Cg L[ tbN
	;
	DW	0A9BCh
	DB	2
	DW	GETKY_HOOK_TITLE

	DW	0AA23h
	DB	2
	DW	GETKY_HOOK_TITLE

	;
	; Q[ L[ tbN
	;
;	DW	0AAD3h
;	DB	2
;	DW	GETKY_HOOK_INGAME

	;
	; t@C^[L[
	;
	DW	0AB4Eh
	DB	3
	CALL	FIGHTER_MOVE_KEY_HOOK

	;
	; t@C^[r[ L[
	;
	DW	0ACFEh
	DB	3
	CALL	FIGHTER_BEAM_KEY_HOOK

	;
	; p[cEL[
	;
	DW	0BC82h
	DB	3
	CALL	FIGHTER_SPECIAL_KEY_HOOK

ENDIF ;;;SIOJOY

IF LPTJOY
	;
	; ^Cg L[ tbN
	;
	DW	0A9BCh
	DB	2
	DW	GETKY_HOOK_TITLE

	DW	0AA23h
	DB	2
	DW	GETKY_HOOK_TITLE

	;
	; t@C^[L[
	;
	DW	0AB4Eh
	DB	3
	CALL	FIGHTER_MOVE_KEY_HOOK

	;
	; t@C^[r[ L[
	;
	DW	0ACFEh
	DB	3
	CALL	FIGHTER_BEAM_KEY_HOOK

	;
	; p[cEL[
	;
	DW	0BC82h
	DB	3
	CALL	FIGHTER_SPECIAL_KEY_HOOK

ENDIF ;;;LPTJOY

IF AM7JOY
	;
	; ^Cg L[ tbN
	;
	DW	0A9BCh
	DB	2
	DW	GETKY_HOOK_TITLE

	DW	0AA23h
	DB	2
	DW	GETKY_HOOK_TITLE

	;
	; Q[ L[ tbN
	;
	DW	0AAD3h
	DB	2
	DW	GETKY_HOOK_INGAME

	;
	; t@C^[L[
	;
	DW	0AB4Eh
	DB	3
	CALL	FIGHTER_MOVE_KEY_HOOK

	;
	; t@C^[r[ L[
	;
	DW	0ACFEh
	DB	3
	CALL	FIGHTER_BEAM_KEY_HOOK

	;
	; p[cEL[
	;
	DW	0BC82h
	DB	3
	CALL	FIGHTER_SPECIAL_KEY_HOOK

ENDIF ;;;AM7JOY

	;
	; pb`f[^I
	;
	DW	0

	END
